#include <Magick++.h>
#include <iostream>
#include <tiffio.h>

#include "baseapi.h"
#include "tesseractmain.h"
#include "imgs.h"

extern void read_tiff_image(TIFF* tif, IMAGE* image);

using namespace tesseract;

int main(int argc, char* argv[])
{
  const char* file = "image.png";
  const char* tifName = "test.tif";
  
  // Conversion avec ImageMagick
  Magick::Image img;
  img.read(file);
  img.write(tifName);

  // Chargement de l'image en mémoire
  FILE* fp = fopen(tifName, "rb");
  TIFF* archive = TIFFOpen(tifName, "r");
  
  IMAGE image;
  read_tiff_image(archive, &image);
  TIFFClose(archive);
  fclose(fp);

  // Utilisation de Tesseract
  TessBaseAPI* api = new TessBaseAPI();
  api->Init(argv[0], "fra");
  api->SetAccuracyVSpeed(AVS_MOST_ACCURATE);

  int bytes_per_line = check_legal_image_size(image.get_xsize(), image.get_ysize(), image.get_bpp());
  api->SetImage(image.get_buffer(), image.get_xsize(), image.get_ysize(), image.get_bpp()/8, bytes_per_line);
  const char* text = api->GetUTF8Text();
  printf("Text: %s\n", text);

  return 0;
}
